diff -BbruN freeswan-1.91.orig/pluto/xmap_ldap.c freeswan-1.91/pluto/xmap_ldap.c
--- freeswan-1.91.orig/pluto/xmap_ldap.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/xmap_ldap.c	Tue Jul  3 03:00:39 2001
@@ -0,0 +1,1369 @@
+#ifdef OPENSSL
+#ifdef HAVE_LDAP
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <setjmp.h>
+#include <signal.h>
+#include <ctype.h>
+#include <errno.h>
+#include <sys/time.h>
+#include <regex.h>
+
+#include <lber.h>
+#include <ldap.h>
+
+#include "x_sobj.h"
+#include "xmap.h"
+#include "xmap_ldap.h"
+
+#include <openssl/x509v3.h>
+
+#include <freeswan.h> /* needed by constants.h */
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+#include "whack.h"
+
+static void XMAP_LDAP_dump(void *this);
+static void XMAP_LDAP_free(void *this);
+static void *XMAP_LDAP_new(const char *ldap);
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup( void *this, const int type, const char *index, void *p );
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_subject( XMAP_LDAP *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_issuer( XMAP_LDAP *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_crl_by_issuer( XMAP_LDAP *xm, X509_NAME *name );
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_uid( XMAP_LDAP *xm, const char *uid );
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_dns( XMAP_LDAP *xm, const char *dns );
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_ip( XMAP_LDAP *xm, const struct in_addr ip );
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_ca_certs( XMAP_LDAP *xm );
+static char **make_attrs( const char *a );
+static void attrs_free( char **attrs );
+
+char *find_filter( const char *index, const int type, flist *fl );
+char **find_attrs( const char *index, const int type, alist *al );
+
+static XMAP_METHOD xmap_ldap_methods = {
+  "ldap",
+  XMAP_LDAP_lookup,
+  XMAP_LDAP_dump,
+  XMAP_LDAP_free,
+  XMAP_LDAP_new
+};
+
+#define HOST_REGEX "^([[:alnum:]]+)_host_name[[:space:]]*=[[:space:]]*([[:punct:][:alnum:]]+)"
+#define PORT_REGEX "^([[:alnum:]]+)_port[[:space:]]*=[[:space:]]*([[:digit:]]+)"
+#define BASE_REGEX "^([[:alnum:]]+)_base[[:space:]]*=[[:space:]]*([^[:space:]].*)"
+#define TIMEOUT_REGEX "^([[:alnum:]]+)_timeout[[:space:]]*=[[:space:]]*([[:digit:]]+)"
+#define BINDDN_REGEX "^([[:alnum:]]+)_bind_dn[[:space:]]*=[[:space:]]*([^[:space:]].*)"
+#define BINDPW_REGEX "^([[:alnum:]]+)_password[[:space:]]*=[[:space:]]*([^[:space:]].*)"
+#define FILTER_REGEX "^([[:alnum:]]+)_filter(:(([\\*[:alnum:]]+)(:([[:alnum:]]+))?))?[[:space:]]*=[[:space:]]*([^[:space:]].*)"
+#define ATTRS_REGEX "^([[:alnum:]]+)_attributes(:(([\\*[:alnum:]]+)(:([[:alnum:]]+))?))?[[:space:]]*=[[:space:]]*([^[:space:]].*)"
+
+static void
+insert_filter( const char *index, const int type, const char *filter, flist *fl )
+{
+  int i;
+  char *f, *in;
+
+  for(i=0; ((i < MAXFLIST) && (fl[i].index)) ;i++)
+    if ((strcasecmp(index, fl[i].index) == 0) && (fl[i].type == type)) break;
+
+  if (i == MAXFLIST) return; /* No more room */
+  if (fl[i].index) {
+    /* A replacement operation */
+    if ((f = clone_bytes(filter, strlen(filter)+1, "filter")) == NULL) return;
+    pfree(fl[i].filter);
+    fl[i].filter = f;
+  } else {
+    if ((in = clone_bytes(index, strlen(index)+1, "index string")) == NULL)
+      return;
+    if ((f = clone_bytes(filter, strlen(filter)+1, "filter string")) == NULL)
+      { pfree(in); return; }
+    fl[i].index = in;
+    fl[i].type = type;
+    fl[i].filter = f;
+
+    DBG(DBG_PARSING,
+    DBG_log("Insert filter: %d (%s,%d,%s)", i+1, in, type, f);
+    );
+  }
+}
+
+static void
+insert_attrs( const char *index, const int type, const char *attr, alist *al )
+{
+  int i, j;
+  char **af, *in;
+
+  for(i=0; ((i < MAXFLIST) && (al[i].index)) ;i++) {
+    if ((strcasecmp(index, al[i].index) == 0) && (al[i].type == type)) {
+      break;
+    }
+  }
+
+  if (i == MAXFLIST) return; /* No more room */
+  if (al[i].index) {
+    /* A replacement operation */
+    if ((af = make_attrs(attr)) == NULL) return;
+    attrs_free(al[i].attrs);
+    al[i].attrs = af;
+  } else {
+    if ((in = clone_bytes(index, strlen(index)+1, "index string")) == NULL)
+      return;
+    if ((af = make_attrs(attr)) == NULL) { pfree(in); return; }
+    al[i].index = in;
+    al[i].type = type;
+    al[i].attrs = af;
+    DBG(DBG_PARSING,
+    DBG_log("Insert attribute: %d (%s,%d)", i+1, in, type);
+    );
+    for(j=0; af[j]; j++)
+      DBG(DBG_PARSING,
+      DBG_log("Attribute %d: %s", j+1, af[j]);
+      );
+  }
+}
+
+char *
+find_filter( const char *index, const int type, flist *fl )
+{
+  int i, OKind;
+  unsigned char OK, indOK, typeOK;
+
+  OK = 0x00;
+  for(i=0, OKind=0; ((i < MAXFLIST) && (fl[i].index)); i++) {
+    typeOK = (fl[i].type == X509_LU_FAIL) ? 0x01 :
+      ((fl[i].type == type) ? 0x04 : 0);
+    indOK = (strcasecmp(fl[i].index, "*") == 0) ? 0x02 :
+      ((strcasecmp(fl[i].index, index) == 0) ? 0x08 : 0);
+    if ((typeOK | indOK) > OK) { OKind = i; OK = typeOK | indOK; }
+  }
+
+  return fl[OKind].filter;
+}
+
+char **
+find_attrs( const char *index, const int type, alist *al )
+{
+  int i, OKind;
+  unsigned char OK, indOK, typeOK;
+
+  OK = 0x00;
+  for(i=0, OKind=0; ((i < MAXFLIST) && (al[i].index)); i++) {
+    typeOK = (al[i].type == X509_LU_FAIL) ? 0x01 :
+      ((al[i].type == type) ? 0x04 : 0);
+    indOK = (strcasecmp(al[i].index, "*") == 0) ? 0x02 :
+      ((strcasecmp(al[i].index, index) == 0) ? 0x08 : 0);
+    if ((typeOK | indOK) > OK) { OKind = i; OK = typeOK | indOK; }
+  }
+
+  return al[OKind].attrs;
+}
+
+static void
+extract_re_sub( const char *buf, regmatch_t *rm, char **lv)
+{
+  if (!buf || !lv || !rm) return;
+  if (*lv) return;
+  if ((rm->rm_so == -1) || (rm->rm_eo == -1)) return;
+  if ((*lv = alloc_bytes(rm->rm_eo - rm->rm_so + 1, "subexpression")) == NULL)
+    return;
+  strncpy(*lv, &buf[rm->rm_so], rm->rm_eo - rm->rm_so);
+  (*lv)[rm->rm_eo - rm->rm_so] = '\0';
+}
+
+static char **
+make_attrs( const char *a )
+{
+  char *s = clone_bytes(a, strlen(a)+1, "attribute list");
+  char *at;
+  int i = 0, j;
+  char **ret = NULL;
+  const char *delim = ", ";
+
+  if (!s) return NULL;
+  at = strtok(s, delim);
+  while (at != NULL) {
+    i++;
+    at = strtok(NULL, delim);
+  }
+  ret = alloc_bytes((i+1) * sizeof(char *), "attribute array");
+  if (!ret) { pfree(s); return NULL; }
+  for(j=0; j<=i; j++) ret[j] = NULL;
+  pfree(s);
+
+  if ((s = clone_bytes(a, strlen(a)+1, "attribute list")) == NULL) return NULL;
+  at = strtok(s, delim);
+  i = 0;
+  while (at != NULL) {
+    if ((ret[i++] = clone_bytes(at, strlen(at)+1, "attribute")) == NULL) {
+      for(i=0; ret[i]; i++) pfree(ret[i]);
+      pfree(ret);
+      pfree(s);
+      return NULL;
+    }
+    at = strtok(NULL, delim);
+  }
+  
+  pfree(s);
+  return ret;
+}
+
+static void
+attrs_free( char **attrs )
+{
+  int i=0;
+
+  for(i=0; attrs[i]; i++) pfree(attrs[i]);
+  pfree(attrs);
+}
+
+static jmp_buf env;
+static void
+ldap_timeout(int unused_sig __attribute__((unused)))
+{
+  longjmp(env, 1);
+}
+
+static int
+open_bind( XMAP_LDAP *xm )
+{
+  void (*saved_alarm)(int);
+
+  if ((saved_alarm = signal(SIGALRM, ldap_timeout)) == SIG_ERR) {
+    log("signal: %s", strerror(errno));
+    return 0;
+  }
+
+  alarm(xm->ldap_timeout);
+  if (setjmp(env) == 0) {
+    if ((xm->ld = ldap_open(xm->ldap_host, xm->ldap_port)) == NULL) {
+      alarm(0); /* turn it off */
+      DBG(DBG_PARSING,
+      DBG_log("Open to %s:%d failed", xm->ldap_host, xm->ldap_port);
+      );
+      loglog(RC_LOG_SERIOUS, "ldap_open: %s", strerror(errno));
+      return 0;
+    }
+  } else {
+    DBG(DBG_PARSING,
+    DBG_log("Open to %s:%d failed", xm->ldap_host, xm->ldap_port);
+    );
+    loglog(RC_LOG_SERIOUS, "ldap_open: Connection timed out.");
+    return 0;
+  }
+  alarm(0);
+
+  if ((ldap_bind_s(xm->ld, xm->ldap_bindDN, xm->ldap_bindPW,
+		   LDAP_AUTH_SIMPLE)) != LDAP_SUCCESS) return 0;
+
+  return 1;
+}
+
+void *
+XMAP_LDAP_new(const char *ldapspec)
+{
+  char *ls = NULL, *s, *ldapvar = NULL, *ldapfile;
+  FILE *fp;
+  XMAP_LDAP *ret = NULL;
+  int i, re_code;
+  char re_err[256];
+  regmatch_t re_match[10];
+
+  regex_t host_re;
+  regex_t port_re;
+  regex_t timeout_re;
+  regex_t base_re;
+  regex_t binddn_re;
+  regex_t bindpw_re;
+  regex_t filter_re;
+  regex_t attrs_re;
+
+  /* Default values */
+  char *ldap_host = clone_bytes("localhost", strlen("localhost")+1,
+				"ldap_host");
+  int ldap_port = LDAP_PORT;
+  int ldap_timeout = 10; /* seconds */
+  char *ldap_bindDN = clone_bytes("", 1, "bindDN");
+  char *ldap_bindPW = clone_bytes("", 1, "bindPW");
+  char *ldap_base = NULL;
+  flist ldap_filter[MAXFLIST];
+  alist ldap_attrs[MAXFLIST];
+
+  memset(ldap_filter, 0, sizeof(ldap_filter));
+  insert_filter("*", X509_LU_FAIL, "(cn=%s)", ldap_filter);
+
+  memset(ldap_attrs, 0, sizeof(ldap_attrs));
+  insert_attrs("*", X509_LU_FAIL, "usercertificate, usercertificate;binary, cacertificate, cacertificate;binary", ldap_attrs);
+
+  if ((re_code = regcomp(&host_re, HOST_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &host_re, re_err, sizeof(re_err));
+    log("Regex error: %s", re_err);
+    goto end;
+  }
+
+  if ((re_code = regcomp(&port_re, PORT_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &port_re, re_err, sizeof(re_err));
+    log("Regex error: %s", re_err);
+    goto end;
+  }
+
+  if ((re_code = regcomp(&base_re, BASE_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &base_re, re_err, sizeof(re_err));
+    log("Regex error: %s", re_err);
+    goto end;
+  }
+
+  if ((re_code = regcomp(&timeout_re, TIMEOUT_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &timeout_re, re_err, sizeof(re_err));
+    log("Regex error: %s", re_err);
+    goto end;
+  }
+
+  if ((re_code = regcomp(&binddn_re, BINDDN_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &binddn_re, re_err, sizeof(re_err));
+    log("Regex error: %s", re_err);
+    goto end;
+  }
+
+  if ((re_code = regcomp(&bindpw_re, BINDPW_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &bindpw_re, re_err, sizeof(re_err));
+    log("Regex error: %s", re_err);
+    goto end;
+  }
+
+  if ((re_code = regcomp(&filter_re, FILTER_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &filter_re, re_err, sizeof(re_err));
+    log("Regex error: %s", re_err);
+    goto end;
+  }
+
+  if ((re_code = regcomp(&attrs_re, ATTRS_REGEX, REG_EXTENDED)) != 0) {
+    regerror(re_code, &attrs_re, re_err, sizeof(re_err));
+    log("Regex error: %s", re_err);
+    goto end;
+  }
+
+  if ((!ldap_host) || (!ldap_bindDN) || (!ldap_bindPW) ||
+      (!ldap_filter) || (!ldap_attrs)) goto end;
+
+  if (!ldapspec) goto end;
+  ls = clone_bytes(ldapspec, strlen(ldapspec)+1, "ldap spec");
+  if (!ls) goto end;
+  s = strchr(ls, ':');
+  ldapfile = ls;
+  if (s) {
+    ldapvar = clone_bytes(&s[1], strlen(&s[1])+1, "ldap name");
+    *s = '\0';
+  } else {
+    ldapvar = NULL;
+  }
+
+  fp = fopen( ldapfile, "r" );
+  if (!fp) {
+    perror("fopen");
+    goto end;
+  }
+
+  while (!feof(fp)) {
+    char buf[BUFSIZ], *ptr;
+
+    if (fgets(buf, sizeof(buf), fp)) {
+      int l;
+
+      for(ptr = buf; ((*ptr) && (isspace(*ptr))); ptr++);
+      if (! *ptr) continue; /* Blank Line */
+      if (*ptr == '#') continue; /* Comment */
+      l = strlen(buf)-1;
+      while ((l > 0) && (isspace(buf[l]))) { buf[l] = '\0'; l--; }
+
+      /* Check for host name spec */
+      if ((re_code = regexec(&host_re, buf, 10, re_match, 0)) == 0) {
+	char *lv = NULL;
+
+	extract_re_sub(buf, &re_match[1], &lv);
+	if (!ldapvar) extract_re_sub(buf, &re_match[1], &ldapvar);
+	if (strcmp(ldapvar, lv) == 0) {
+	  if (ldap_host) { pfree(ldap_host); ldap_host = NULL; }
+	  extract_re_sub(buf, &re_match[2], &ldap_host);
+	}
+	pfree(lv);
+      }
+
+      /* Check for port spec */
+      if ((re_code = regexec(&port_re, buf, 10, re_match, 0)) == 0) {
+	char *lv = NULL;
+
+	extract_re_sub(buf, &re_match[1], &lv);
+	if (!ldapvar) extract_re_sub(buf, &re_match[1], &ldapvar);
+	if (strcmp(ldapvar, lv) == 0) {
+	  char *ps = NULL;
+
+	  extract_re_sub(buf, &re_match[2], &ps);
+	  ldap_port = atoi(ps);
+	  pfree(ps);
+	}
+	pfree(lv);
+      }
+
+      /* Check for base spec */
+      if ((re_code = regexec(&base_re, buf, 10, re_match, 0)) == 0) {
+	char *lv = NULL;
+
+	extract_re_sub(buf, &re_match[1], &lv);
+	if (!ldapvar) extract_re_sub(buf, &re_match[1], &ldapvar);
+	if (strcmp(ldapvar, lv) == 0) {
+	  if (ldap_base) { free(ldap_base); ldap_base = NULL; }
+	  extract_re_sub(buf, &re_match[2], &ldap_base);
+	}
+	pfree(lv);
+      }
+
+      /* Check for timeout spec */
+      if ((re_code = regexec(&timeout_re, buf, 10, re_match, 0)) == 0) {
+	char *lv = NULL;
+
+	extract_re_sub(buf, &re_match[1], &lv);
+	if (!ldapvar) extract_re_sub(buf, &re_match[1], &ldapvar);
+	if (strcmp(ldapvar, lv) == 0) {
+	  char *to = NULL;
+
+	  extract_re_sub(buf, &re_match[2], &to);
+	  ldap_timeout = atoi(to);
+	  free(to);
+	}
+	pfree(lv);
+      }
+
+      /* Check for bind DN spec */
+      if ((re_code = regexec(&binddn_re, buf, 10, re_match, 0)) == 0) {
+	char *lv = NULL;
+
+	extract_re_sub(buf, &re_match[1], &lv);
+	if (!ldapvar) extract_re_sub(buf, &re_match[1], &ldapvar);
+	if (strcmp(ldapvar, lv) == 0) {
+	  if (ldap_bindDN) { free(ldap_bindDN); ldap_bindDN = NULL; }
+	  extract_re_sub(buf, &re_match[2], &ldap_bindDN);
+	}
+	pfree(lv);
+      }
+
+      /* Check for bind PW spec */
+      if ((re_code = regexec(&bindpw_re, buf, 10, re_match, 0)) == 0) {
+	char *lv = NULL;
+
+	extract_re_sub(buf, &re_match[1], &lv);
+	if (!ldapvar) extract_re_sub(buf, &re_match[1], &ldapvar);
+	if (strcmp(ldapvar, lv) == 0) {
+	  if (ldap_bindPW) { free(ldap_bindPW); ldap_bindPW = NULL; }
+	  extract_re_sub(buf, &re_match[2], &ldap_bindPW);
+	}
+	pfree(lv);
+      }
+
+      /* Check for filter spec */
+      if ((re_code = regexec(&filter_re, buf, 10, re_match, 0)) == 0) {
+	char *lv = NULL;
+
+	extract_re_sub(buf, &re_match[1], &lv);
+	if (!ldapvar) extract_re_sub(buf, &re_match[1], &ldapvar);
+	if (strcmp(ldapvar, lv) == 0) {
+	  char *filt = NULL, *sf = NULL, *ssf = NULL;
+	  int ssftype = X509_LU_FAIL; /* Use this as a catchall */
+
+	  if (re_match[2].rm_so != -1) {
+	    extract_re_sub(buf, &re_match[4], &sf);
+	    if (re_match[5].rm_so != -1) {
+	      extract_re_sub(buf, &re_match[6], &ssf);
+	      if (strcasecmp(ssf, "cert") == 0)
+		ssftype = X509_LU_X509;
+	      else if (strcasecmp(ssf, "crl") == 0)
+		ssftype = X509_LU_CRL;
+	      else
+		ssftype = X509_LU_RETRY; /* Use as an "invalid" value */
+	      pfree(ssf);
+	    }
+	  }
+	  extract_re_sub(buf, &re_match[7], &filt);
+	  if (ssftype != X509_LU_RETRY)
+	    insert_filter((sf == NULL) ? "*" : sf, ssftype, filt, ldap_filter);
+	  else
+	    if (filt) pfree(filt);
+	  if (sf) pfree(sf);
+	}
+	pfree(lv);
+      }
+
+      /* Check for attributes spec */
+      if ((re_code = regexec(&attrs_re, buf, 10, re_match, 0)) == 0) {
+	char *lv = NULL;
+
+	extract_re_sub(buf, &re_match[1], &lv);
+	if (!ldapvar) extract_re_sub(buf, &re_match[1], &ldapvar);
+	if (strcmp(ldapvar, lv) == 0) {
+	  char *attr = NULL;
+	  char *sf = NULL, *ssf = NULL;
+	  int ssftype = X509_LU_FAIL; /* Use this as a catchall */
+
+	  if (re_match[2].rm_so != -1) {
+	    extract_re_sub(buf, &re_match[4], &sf);
+	    if (re_match[5].rm_so != -1) {
+	      extract_re_sub(buf, &re_match[6], &ssf);
+	      if (strcasecmp(ssf, "cert") == 0)
+		ssftype = X509_LU_X509;
+	      else if (strcasecmp(ssf, "crl") == 0)
+		ssftype = X509_LU_CRL;
+	      else if (strcasecmp(ssf, "*") == 0)
+		ssftype = X509_LU_FAIL;
+	      else
+		ssftype = X509_LU_RETRY; /* Use as an "invalid" value */
+	      pfree(ssf);
+	    }
+	  }
+	  extract_re_sub(buf, &re_match[7], &attr);
+	  if (ssftype != X509_LU_RETRY)
+	    insert_attrs((sf == NULL) ? "*" : sf, ssftype, attr, ldap_attrs);
+	  else
+	    if (attr) pfree(attr);
+	  if (sf) pfree(sf);
+	}
+	pfree(lv);
+      }
+
+    }
+  }
+
+  if (!ldap_base) goto end; /* No search base - and we can't default to one */
+
+  if ((ret = alloc_thing(XMAP_LDAP, "xmap_ldap")) == NULL) goto end;
+
+  ret->ldapsource = ldapvar;
+  ret->ldap_host = ldap_host;
+  ret->ldap_port = ldap_port;
+  ret->ldap_base = ldap_base;
+  ret->ldap_timeout = ldap_timeout;
+  ret->ldap_bindDN = ldap_bindDN;
+  ret->ldap_bindPW = ldap_bindPW;
+  memcpy(ret->ldap_filter, ldap_filter, MAXFLIST * sizeof(flist));
+  memcpy(ret->ldap_attrs, ldap_attrs, MAXFLIST * sizeof(alist));
+  
+  fclose(fp); fp = NULL;
+
+  if (!open_bind(ret)) goto end;
+
+  if (ls) pfree(ls);
+  return (void *)ret;
+
+ end:
+  if (ldap_host) pfree(ldap_host);
+  if (ldap_base) pfree(ldap_base);
+  if (ldap_bindDN) pfree(ldap_bindDN);
+  if (ldap_bindPW) pfree(ldap_bindPW);
+  for(i=0; ldap_filter[i].index; i++)
+    { pfree(ldap_filter[i].index); pfree(ldap_filter[i].filter); }
+  for(i=0; ldap_attrs[i].index; i++)
+    { pfree(ldap_attrs[i].index); attrs_free(ldap_attrs[i].attrs); }
+  if (ldapvar) pfree(ldapvar);
+  if (ls) pfree(ls);
+  if (fp) fclose(fp);
+  return NULL;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup( void *this, const int type, const char *index, void *p )
+{
+  XMAP_LDAP *xm = (XMAP_LDAP *)this;
+
+  if (type == X509_LU_X509) {
+    if (strcasecmp(index, "subject") == 0)
+      return XMAP_LDAP_lookup_cert_by_subject(xm, (X509_NAME *)p);
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_LDAP_lookup_cert_by_issuer(xm, (X509_NAME *)p);
+    else if (strcasecmp(index, "uid") == 0)
+      return XMAP_LDAP_lookup_cert_by_uid(xm, (char *)p);
+    else if (strcasecmp(index, "dns") == 0)
+      return XMAP_LDAP_lookup_cert_by_dns(xm, (char *)p);
+    else if (strcasecmp(index, "ip") == 0)
+      return XMAP_LDAP_lookup_cert_by_ip(xm, *((struct in_addr *)p));
+    else if (strcasecmp(index, "ca") == 0)
+      return XMAP_LDAP_lookup_ca_certs( xm );
+    else
+      return NULL;
+  } else if (type == X509_LU_CRL) {
+    if (strcasecmp(index, "issuer") == 0)
+      return XMAP_LDAP_lookup_crl_by_issuer(xm, (X509_NAME *)p);
+    else
+      return NULL;
+  } else {
+    log("Unknown search type");
+    return NULL;
+  }
+}
+
+static int
+ASN1_UTCTIME_cmp(ASN1_UTCTIME *a, ASN1_UTCTIME *b)
+{
+  char buff1[14],buff2[14],*p;
+  int i,j;
+ 
+  /* Degenerate cases */
+  if (!a && !b) return 0;
+  if (a && !b) return 1;
+  if (!a && b) return -1;
+ 
+  memset(buff1, 0, sizeof(buff1));
+  memset(buff2, 0, sizeof(buff2));
+ 
+  p=buff1;
+  i=a->length;
+  if ((i < 11) || (i > 17)) return(0);
+  memcpy(p,a->data,12);
+ 
+  p=buff2;
+  j=b->length;
+  if ((j < 11) || (j > 17)) return(0);
+  memcpy(p,b->data,12);
+ 
+  /* Correct for Y2K */
+  i=(buff1[0]-'0')*10+(buff1[1]-'0');
+  if (i < 50) i+=100; /* cf. RFC 2459 */
+  j=(buff2[0]-'0')*10+(buff2[1]-'0');
+  if (j < 50) j+=100;
+ 
+  if (i < j) return (-1);
+  if (i > j) return (1);
+ 
+  i=strcmp(buff1,buff2);
+ 
+  if (i == 0)
+    return 0;
+  else if (i < 0)
+    return(-1);
+  else
+    return(1);
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_subject( XMAP_LDAP *xm, X509_NAME *name )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  char *str, *s1, *ff, **af;
+  int i, j, tlen, rc;
+  LDAPMessage *res = NULL, *ent = NULL;
+  struct timeval tv;
+  struct berval **bv;
+
+  if (!sk) return NULL;
+  if (!xm->ld)
+    if (!open_bind(xm)) return NULL;
+
+/*
+ * Searching by 'common name' alone is wrong. Will let the code
+ * from the original author remain until a better solution is found.
+ * 
+ *  // First find the 'common name' attribute from the subject
+ *  for(i=0; i<sk_X509_NAME_ENTRY_num(ns); i++) {
+ *    X509_NAME_ENTRY *ne = sk_X509_NAME_ENTRY_value(ns, i);
+ *    int nid = OBJ_obj2nid(ne->object);
+ * 
+ *    if (nid == NID_commonName) {
+ *      if (!(str = alloc_bytes(ASN1_STRING_length(ne->value)+1, "common name")))
+ * return sk;
+ *      memset(str, 0, ASN1_STRING_length(ne->value)+1);
+ *      memcpy(str, ASN1_STRING_data(ne->value),
+ *             ASN1_STRING_length(ne->value));
+ *      break; 
+ *    }
+ *  }
+ */
+
+/* Use the whole DN */
+  str = X509_NAME_oneline(name, NULL, 0);
+
+  ff = find_filter("subject", X509_LU_X509, xm->ldap_filter);
+  af = find_attrs("subject", X509_LU_X509, xm->ldap_attrs);
+  tlen = strlen(ff) + strlen(str);
+  if ((s1 = alloc_bytes(tlen, "filter pattern")) != NULL) {
+    snprintf(s1, tlen, ff, str);
+    tv.tv_sec = xm->ldap_timeout; tv.tv_usec = 0;
+    rc = ldap_search_st(xm->ld, xm->ldap_base, LDAP_SCOPE_SUBTREE,
+			s1, af, 0,
+			&tv, &res);
+    if (rc == LDAP_SUCCESS) {
+      for(ent = ldap_first_entry(xm->ld, res); ent ;
+	  ent = ldap_next_entry(xm->ld, ent)) {
+	for(i = 0; af[i]; i++) {
+	  bv = ldap_get_values_len(xm->ld, ent, af[i]);
+	  if (bv) {
+	    for(j=0; bv[j]; j++) {
+	      unsigned char *p;
+	      X509 *x;
+
+
+	      p = bv[j]->bv_val;
+	      x = d2i_X509(NULL, &p, bv[j]->bv_len);
+	      if (x) {
+
+		if (X509_NAME_cmp(X509_get_subject_name(x), name) == 0) {
+		  X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+		  if (xo) {
+		    int i, found = 0;
+
+		    for(i=0; (!found) && (i<sk_X509_OBJECT_num(sk)); i++) {
+		      X509_OBJECT *o = sk_X509_OBJECT_value(sk, i);
+
+		      if (X509_issuer_and_serial_cmp(x, o->data.x509) == 0)
+			found = 1;
+		    }
+		    if (!found)
+		      sk_X509_OBJECT_push(sk, xo);
+		    else {
+		      X509_free(x); /* duplicate of existing item */
+		    }
+		  } else {
+		    X509_free(x); /* cannot allocate X509_OBJECT */
+		  }
+		} else {
+		  X509_free(x); /* subject name doesn't match */
+		}
+	      }
+	    }
+	    ldap_value_free_len(bv);
+	  }
+	}
+      }
+    } else {
+      log("ldap_search_st error: %s", ldap_err2string(rc));
+      ldap_unbind(xm->ld);
+      xm->ld = NULL;
+    }
+    pfree(s1);
+  }
+  pfree(str);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_issuer( XMAP_LDAP *xm, X509_NAME *name )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  char *str, *s1, *ff, **af;
+  int i, j, tlen, rc;
+  LDAPMessage *res = NULL, *ent = NULL;
+  struct timeval tv;
+  struct berval **bv;
+
+  if (!sk) return NULL;
+  if (!xm->ld)
+    if (!open_bind(xm)) return NULL;
+
+  str = X509_NAME_oneline(name, NULL, 0);
+
+  ff = find_filter("issuer", X509_LU_X509, xm->ldap_filter);
+  af = find_attrs("issuer", X509_LU_X509, xm->ldap_attrs);
+  tlen = strlen(ff) + strlen(str);
+  if ((s1 = alloc_bytes(tlen, "filter pattern")) != NULL) {
+    snprintf(s1, tlen, ff, str);
+    tv.tv_sec = xm->ldap_timeout; tv.tv_usec = 0;
+    rc = ldap_search_st(xm->ld, xm->ldap_base, LDAP_SCOPE_SUBTREE,
+			s1, af, 0,
+			&tv, &res);
+    if (rc == LDAP_SUCCESS) {
+      for(ent = ldap_first_entry(xm->ld, res); ent ;
+	  ent = ldap_next_entry(xm->ld, ent)) {
+	for(i = 0; af[i]; i++) {
+	  bv = ldap_get_values_len(xm->ld, ent, af[i]);
+	  if (bv) {
+	    for(j=0; bv[j]; j++) {
+	      unsigned char *p;
+	      X509 *x;
+
+
+	      p = bv[j]->bv_val;
+	      x = d2i_X509(NULL, &p, bv[j]->bv_len);
+	      if (x) {
+
+		if (X509_NAME_cmp(X509_get_issuer_name(x), name) == 0) {
+		  X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+		  if (xo) {
+		    int i, found = 0;
+
+		    for(i=0; (!found) && (i<sk_X509_OBJECT_num(sk)); i++) {
+		      X509_OBJECT *o = sk_X509_OBJECT_value(sk, i);
+
+		      if (X509_issuer_and_serial_cmp(x, o->data.x509) == 0)
+			found = 1;
+		    }
+		    if (!found)
+		      sk_X509_OBJECT_push(sk, xo);
+		    else {
+		      X509_free(x); /* duplicate of existing item */
+		    }
+		  } else {
+		    X509_free(x); /* cannot allocate X509_OBJECT */
+		  }
+		} else {
+		  X509_free(x); /* subject name doesn't match */
+		}
+	      }
+	    }
+	    ldap_value_free_len(bv);
+	  }
+	}
+      }
+    } else {
+      log("ldap_search_st error: %s", ldap_err2string(rc));
+      ldap_unbind(xm->ld);
+      xm->ld = NULL;
+    }
+    pfree(s1);
+  }
+  pfree(str);
+  return sk;
+}
+
+static int
+isCA( X509 *x )
+{
+  X509_EXTENSION *ext;
+  BASIC_CONSTRAINTS *p = NULL;
+  int loc;
+  
+  loc = X509_get_ext_by_NID(x, NID_basic_constraints, -1);
+  if (loc >= 0) {
+    ext = X509_get_ext(x, loc);
+    if (ext) {
+      p = X509V3_EXT_d2i(ext);
+      if (! p->ca) {
+	BASIC_CONSTRAINTS_free(p);
+	return 0;
+      } else {
+	BASIC_CONSTRAINTS_free(p);
+	return 1; /* This is a CA certificate */
+      }
+    } else
+      return 0;
+  } else
+    return 0;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_ca_certs( XMAP_LDAP *xm )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  char *ff, **af;
+  int i, j, rc;
+  LDAPMessage *res = NULL, *ent = NULL;
+  struct timeval tv;
+  struct berval **bv;
+
+  if (!sk) return NULL;
+  if (!xm->ld)
+    if (!open_bind(xm)) return NULL;
+
+  ff = find_filter("ca", X509_LU_X509, xm->ldap_filter);
+  af = find_attrs("ca", X509_LU_X509, xm->ldap_attrs);
+  tv.tv_sec = xm->ldap_timeout; tv.tv_usec = 0;
+  rc = ldap_search_st(xm->ld, xm->ldap_base, LDAP_SCOPE_SUBTREE,
+		      ff, af, 0, &tv, &res);
+  if (rc == LDAP_SUCCESS) {
+    for(ent = ldap_first_entry(xm->ld, res); ent ;
+	ent = ldap_next_entry(xm->ld, ent)) {
+      for(i = 0; af[i]; i++) {
+	bv = ldap_get_values_len(xm->ld, ent, af[i]);
+	if (bv) {
+	  for(j=0; bv[j]; j++) {
+	    unsigned char *p;
+	    X509 *x;
+	    
+	    p = bv[j]->bv_val;
+	    x = d2i_X509(NULL, &p, bv[j]->bv_len);
+	    if ((x) && (isCA(x))) {
+	      X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+	      if (xo) {
+		int i, found = 0;
+		
+		for(i=0; (!found) && (i<sk_X509_OBJECT_num(sk)); i++) {
+		  X509_OBJECT *o = sk_X509_OBJECT_value(sk, i);
+		  
+		  if (X509_issuer_and_serial_cmp(x, o->data.x509) == 0)
+		    found = 1;
+		}
+		if (!found)
+		  sk_X509_OBJECT_push(sk, xo);
+		else
+		  X509_free(x); /* duplicate of existing item */
+	      } else
+		X509_free(x); /* cannot allocate X509_OBJECT */
+	    } else
+	      X509_free(x); /* subject name doesn't match */
+	  }
+	  ldap_value_free_len(bv);
+	}
+      }
+    }
+  } else {
+    log("ldap_search_st error: %s", ldap_err2string(rc));
+    ldap_unbind(xm->ld);
+    xm->ld = NULL;
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_crl_by_issuer( XMAP_LDAP *xm, X509_NAME *name )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  STACK_OF(X509_NAME_ENTRY) *ns = name->entries;
+  char *str, *s1, *ff, **af;
+  int i, j, tlen, rc;
+  LDAPMessage *res = NULL, *ent = NULL;
+  struct timeval tv;
+  struct berval **bv;
+
+  if (!sk) return NULL;
+  if (!xm->ld)
+    if (!open_bind(xm)) return NULL;
+
+  /* First find the 'common name' attribute from the subject */
+  for(i=0; i<sk_X509_NAME_ENTRY_num(ns); i++) {
+    X509_NAME_ENTRY *ne = sk_X509_NAME_ENTRY_value(ns, i);
+    int nid = OBJ_obj2nid(ne->object);
+
+    if (nid == NID_commonName) {
+      if (!(str = alloc_bytes(ASN1_STRING_length(ne->value)+1,
+			      "common name")))
+	return sk;
+      memset(str, 0, ASN1_STRING_length(ne->value)+1);
+      memcpy(str, ASN1_STRING_data(ne->value),
+             ASN1_STRING_length(ne->value));
+      break; 
+    }
+  }
+  ff = find_filter("issuer", X509_LU_CRL, xm->ldap_filter);
+  af = find_attrs("issuer", X509_LU_CRL, xm->ldap_attrs);
+  tlen = strlen(ff) + strlen(str);
+  if ((s1 = alloc_bytes(tlen, "filter pattern")) != NULL) {
+    snprintf(s1, tlen, ff, str);
+    tv.tv_sec = xm->ldap_timeout; tv.tv_usec = 0;
+    DBG(DBG_PARSING,
+    DBG_log("LDAP search: \"%s\"", s1);
+    );
+    for(i=0; af[i]; i++) {
+      DBG(DBG_PARSING,
+      DBG_log("Attr %d: %s", i+1, af[i]);
+      );
+    }
+    rc = ldap_search_st(xm->ld, xm->ldap_base, LDAP_SCOPE_SUBTREE,
+			s1, af, 0,
+			&tv, &res);
+    if (rc == LDAP_SUCCESS) {
+      for(ent = ldap_first_entry(xm->ld, res); ent ;
+	  ent = ldap_next_entry(xm->ld, ent)) {
+	for(i = 0; af[i]; i++) {
+	  bv = ldap_get_values_len(xm->ld, ent, af[i]);
+	  if (bv) {
+	    for(j=0; bv[j]; j++) {
+	      unsigned char *p;
+	      X509_CRL *x;
+	      
+	      p = bv[j]->bv_val;
+	      x = d2i_X509_CRL(NULL, &p, bv[j]->bv_len);
+	      if (x) {
+		if (X509_NAME_cmp(X509_CRL_get_issuer(x), name) == 0) {
+		  X509_OBJECT *xo = X509_OBJECT_new(X509_LU_CRL, x);
+
+		  if (xo) {
+		    int i, found = 0;
+
+		    for(i=0; (!found) && (i<sk_X509_OBJECT_num(sk)); i++) {
+		      X509_OBJECT *o = sk_X509_OBJECT_value(sk, i);
+
+		      if ((X509_CRL_cmp(o->data.crl, x) == 0) &&
+			  (ASN1_UTCTIME_cmp(X509_CRL_get_lastUpdate(o->data.crl),
+					    X509_CRL_get_lastUpdate(x)) == 0) &&
+			  (ASN1_UTCTIME_cmp(X509_CRL_get_nextUpdate(o->data.crl),
+					    X509_CRL_get_nextUpdate(x)) == 0))
+			  found = 1;
+		    }
+		    if (!found)
+		      sk_X509_OBJECT_push(sk, xo);
+		    else
+		      X509_CRL_free(x); /* duplicate of existing item */
+		  } else
+		    X509_CRL_free(x); /* cannot allocate X509_OBJECT */
+		} else
+		  X509_CRL_free(x); /* subject name doesn't match */
+	      }
+	    }
+	    ldap_value_free_len(bv);
+	  }
+	}
+      }
+    } else {
+      log("ldap_search_st error: %s", ldap_err2string(rc));
+      ldap_unbind(xm->ld);
+      xm->ld = NULL;
+    }
+    pfree(s1);
+  }
+  pfree(str);
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_uid( XMAP_LDAP *xm, const char *uid )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  char *s1, *ff, **af;
+  int i, j, tlen, rc;
+  LDAPMessage *res = NULL, *ent = NULL;
+  struct timeval tv;
+  struct berval **bv;
+
+  if (!sk) return NULL;
+  if (!xm->ld)
+    if (!open_bind(xm)) return NULL;
+
+  ff = find_filter("uid", X509_LU_X509, xm->ldap_filter);
+  af = find_attrs("uid", X509_LU_X509, xm->ldap_attrs);
+  tlen = strlen(ff) + strlen(uid);
+  if ((s1 = alloc_bytes(tlen, "filter pattern")) != NULL) {
+    snprintf(s1, tlen, ff, uid);
+    tv.tv_sec = xm->ldap_timeout; tv.tv_usec = 0;
+    rc = ldap_search_st(xm->ld, xm->ldap_base, LDAP_SCOPE_SUBTREE,
+			s1, af, 0,
+			&tv, &res);
+    if (rc == LDAP_SUCCESS) {
+      for(ent = ldap_first_entry(xm->ld, res); ent ;
+	  ent = ldap_next_entry(xm->ld, ent)) {
+	for(i = 0; af[i]; i++) {
+	  bv = ldap_get_values_len(xm->ld, ent, af[i]);
+	  if (bv) {
+	    for(j=0; bv[j]; j++) {
+	      unsigned char *p;
+	      X509 *x;
+	      
+	      p = bv[j]->bv_val;
+	      x = d2i_X509(NULL, &p, bv[j]->bv_len);
+	      if (x) {
+		X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+		if (xo) {
+		  int i, found = 0;
+		  
+		  for(i=0; (!found) && (i<sk_X509_OBJECT_num(sk)); i++) {
+		    X509_OBJECT *o = sk_X509_OBJECT_value(sk, i);
+		    
+		    if (X509_issuer_and_serial_cmp(x, o->data.x509) == 0)
+		      found = 1;
+		  }
+		  if (!found)
+		    sk_X509_OBJECT_push(sk, xo);
+		  else
+		    X509_free(x); /* duplicate of existing item */
+		} else
+		  X509_free(x); /* cannot allocate X509_OBJECT */
+	      }
+	    }
+	    ldap_value_free_len(bv);
+	  }
+	}
+      }
+    } else {
+      log("ldap_search_st error: %s", ldap_err2string(rc));
+      ldap_unbind(xm->ld);
+      xm->ld = NULL;
+    }
+    pfree(s1);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_dns( XMAP_LDAP *xm, const char *dns )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  char *s1, *ff, **af;
+  int i, j, tlen, rc;
+  LDAPMessage *res = NULL, *ent = NULL;
+  struct timeval tv;
+  struct berval **bv;
+
+  if (!sk) return NULL;
+  if (!xm->ld)
+    if (!open_bind(xm)) return NULL;
+
+  ff = find_filter("dns", X509_LU_X509, xm->ldap_filter);
+  af = find_attrs("dns", X509_LU_X509, xm->ldap_attrs);
+  tlen = strlen(ff) + strlen(dns);
+  if ((s1 = alloc_bytes(tlen, "filter patten")) != NULL) {
+    snprintf(s1, tlen, ff, dns);
+    tv.tv_sec = xm->ldap_timeout; tv.tv_usec = 0;
+    rc = ldap_search_st(xm->ld, xm->ldap_base, LDAP_SCOPE_SUBTREE,
+			s1, af, 0,
+			&tv, &res);
+    if (rc == LDAP_SUCCESS) {
+      for(ent = ldap_first_entry(xm->ld, res); ent ;
+	  ent = ldap_next_entry(xm->ld, ent)) {
+	for(i = 0; af[i]; i++) {
+	  bv = ldap_get_values_len(xm->ld, ent, af[i]);
+	  if (bv) {
+	    for(j=0; bv[j]; j++) {
+	      unsigned char *p;
+	      X509 *x;
+	      
+	      p = bv[j]->bv_val;
+	      x = d2i_X509(NULL, &p, bv[j]->bv_len);
+	      if (x) {
+		if (X509_subjAltName_check_dns(x, dns)) {
+		  X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+		  if (xo) {
+		    int i, found = 0;
+		    
+		    for(i=0; (!found) && (i<sk_X509_OBJECT_num(sk)); i++) {
+		      X509_OBJECT *o = sk_X509_OBJECT_value(sk, i);
+		      
+		      if (X509_issuer_and_serial_cmp(x, o->data.x509) == 0)
+			found = 1;
+		    }
+		    if (!found)
+		      sk_X509_OBJECT_push(sk, xo);
+		    else
+		      X509_free(x); /* duplicate of existing item */
+		  } else
+		    X509_free(x); /* cannot allocate X509_OBJECT */
+		} else
+		  X509_free(x); /* subjAltName mismatch */
+	      }
+	    }
+	    ldap_value_free_len(bv);
+	  }
+	}
+      }
+    } else {
+      log("ldap_search_st error: %s", ldap_err2string(rc));
+      ldap_unbind(xm->ld);
+      xm->ld = NULL;
+    }
+    pfree(s1);
+  }
+  return sk;
+}
+
+static STACK_OF(X509_OBJECT) *
+XMAP_LDAP_lookup_cert_by_ip( XMAP_LDAP *xm, const struct in_addr ip )
+{
+  STACK_OF(X509_OBJECT) *sk = sk_X509_OBJECT_new_null();
+  char *s1, *ff, **af, *ipt;
+  int i, j, tlen, rc;
+  LDAPMessage *res = NULL, *ent = NULL;
+  struct timeval tv;
+  struct berval **bv;
+
+  if (!sk) return NULL;
+  if (!xm->ld)
+    if (!open_bind(xm)) return NULL;
+
+  if ((ipt = inet_ntoa(ip)) == NULL) return NULL;
+  ff = find_filter("ip", X509_LU_X509, xm->ldap_filter);
+  af = find_attrs("ip", X509_LU_X509, xm->ldap_attrs);
+  
+  tlen = strlen(ff) + strlen(ipt);
+  if ((s1 = alloc_bytes(tlen, "filter pattern")) != NULL) {
+    snprintf(s1, tlen, ff, ipt);
+    tv.tv_sec = xm->ldap_timeout; tv.tv_usec = 0;
+
+    DBG(DBG_PARSING, 
+    DBG_log("xm->ldap_base: %s -- s1: %s -- *af: %s", xm->ldap_base, s1, *af);
+    );
+
+    rc = ldap_search_st(xm->ld, xm->ldap_base, LDAP_SCOPE_SUBTREE,
+			s1, af, 0,
+			&tv, &res);
+    if (rc == LDAP_SUCCESS) {
+      for(ent = ldap_first_entry(xm->ld, res); ent ;
+	  ent = ldap_next_entry(xm->ld, ent)) {
+        for(i = 0; af[i]; i++) {
+          DBG(DBG_PARSING,
+          DBG_log("af[%d]: [%s]", i, af[i]);
+          );
+
+          bv = ldap_get_values_len(xm->ld, ent, af[i]);
+	  if (bv) {
+	    for(j=0; bv[j]; j++) {
+	      unsigned char *p;
+	      X509 *x;
+	      
+          DBG(DBG_PARSING,
+          DBG_log("** We got LDAP. Trying to process. j=%d.", j);
+          );
+
+          DBG(DBG_PARSING | DBG_RAW,
+          DBG_log("** length of X509 cert: %d", (int )bv[j]->bv_len);
+          );
+          DBG(DBG_RAW,
+          DBG_dump("** p: ", bv[j]->bv_val, bv[j]->bv_len);
+          );
+
+	      p = bv[j]->bv_val;
+	      x = d2i_X509(NULL, &p, bv[j]->bv_len);
+	      if (x) {
+            if (X509_subjAltName_check_ip(x, ip)) {
+              X509_OBJECT *xo = X509_OBJECT_new(X509_LU_X509, x);
+              if (xo) {
+                int i, found = 0;
+		    
+                for(i=0; (!found) && (i<sk_X509_OBJECT_num(sk)); i++) {
+                  X509_OBJECT *o = sk_X509_OBJECT_value(sk, i);
+		      
+                  if (X509_issuer_and_serial_cmp(x, o->data.x509) == 0)
+                    found = 1;
+                } /* end for */
+                if (!found)
+                  sk_X509_OBJECT_push(sk, xo);
+                else
+                  X509_free(x); /* duplicate of existing item */
+              }  /* end if (xo) */
+              else
+                X509_free(x); /* cannot allocate X509_OBJECT */
+            } /* end if (X509_subjAltName_check_ip(x, ip)) */
+            else
+              X509_free(x); /* SubjectAltName mismatch */
+          } /* end if (x) */
+          else
+          {
+          }
+        }
+        ldap_value_free_len(bv);
+      }
+    }
+  }
+    } else {
+      DBG(DBG_PARSING,
+      DBG_log("ldap_search_st error: %s", ldap_err2string(rc));
+      );
+      ldap_unbind(xm->ld);
+      xm->ld = NULL;
+    }
+    pfree(s1);
+  }
+  return sk;
+}
+
+static void
+sanitize(const char *buf, char *buf2, int buf2len)
+{
+  int l = strlen(buf), i, nl, p;
+  char *b;
+
+  for(i=0, nl=l; i<l; i++) if (buf[i] == '%') nl++;
+  b = alloc_bytes(nl+1, "temporary string");
+  memset(b, 0, nl+1);
+  for(i=0, p=0; i < nl; i++) {
+    if (buf[i] == '%') {
+      b[p] = '%';
+      b[p+1] = '%';
+      p++;
+    } else {
+      b[p] = buf[i];
+    }
+    p++;
+  }
+  strncpy(buf2, b, buf2len-1);
+  pfree(b);
+}
+
+static void
+XMAP_LDAP_dump(void *this)
+{
+  char buf[256];
+  XMAP_LDAP *xm = (XMAP_LDAP *)this;
+  int i, j;
+
+  DBG(DBG_PARSING,
+  DBG_log("XMAP_LDAP: %s", xm->ldapsource);
+  DBG_log("Host = %s:%d (Timeout = %d seconds)",
+	  xm->ldap_host, xm->ldap_port, xm->ldap_timeout);
+  DBG_log("Search base = %s", xm->ldap_base);
+  DBG_log("Bind = (\"%s\", \"%s\")", xm->ldap_bindDN, xm->ldap_bindPW);
+  );
+  for(i=0; ((i < MAXFLIST) && (xm->ldap_filter[i].index)); i++) {
+    snprintf(buf, sizeof(buf)-1, "Filter[%d] (%s,",
+	     i+1, xm->ldap_filter[i].index);
+    switch(xm->ldap_filter[i].type) {
+      case X509_LU_X509: strncat(buf, "Cert", sizeof(buf)-1); break;
+      case X509_LU_CRL: strncat(buf, "CRL", sizeof(buf)-1); break;
+      default: strncat(buf, "*", sizeof(buf)-1); break;
+    }
+    strncat(buf, ") ", sizeof(buf)-1);
+    strncat(buf, xm->ldap_filter[i].filter, sizeof(buf)-1);
+    sanitize(buf, buf, sizeof(buf)-1);
+    DBG(DBG_PARSING,
+    DBG_log(buf);
+    );
+  }
+  for(i=0; ((i < MAXFLIST) && (xm->ldap_attrs[i].index)); i++) {
+    snprintf(buf, sizeof(buf), "Attributes[%d] (%s,",
+	     i+1, xm->ldap_attrs[i].index);
+    switch(xm->ldap_attrs[i].type) {
+      case X509_LU_X509: strncat(buf, "Cert", sizeof(buf)-1); break;
+      case X509_LU_CRL: strncat(buf, "CRL", sizeof(buf)-1); break;
+      default: strncat(buf, "*", sizeof(buf)-1); break;
+    }
+    strncat(buf, ") ", sizeof(buf)-1);
+    for(j=0; xm->ldap_attrs[i].attrs[j]; j++) {
+      strncat(buf, ",", sizeof(buf)-1);
+      strncat(buf, xm->ldap_attrs[i].attrs[j], sizeof(buf)-1);
+    }
+    sanitize(buf, buf, sizeof(buf)-1);
+    DBG(DBG_PARSING,
+    DBG_log(buf);
+    );
+  }
+}
+
+static void
+XMAP_LDAP_free(void *this)
+{
+  XMAP_LDAP *xm = (XMAP_LDAP *)this;
+  int i;
+
+  if (!xm) return;
+  if (xm->ld) ldap_unbind(xm->ld);
+  if (xm->ldapsource) pfree(xm->ldapsource);
+  if (xm->ldap_host) pfree(xm->ldap_host);
+  if (xm->ldap_base) pfree(xm->ldap_base);
+  if (xm->ldap_bindDN) pfree(xm->ldap_bindDN);
+  if (xm->ldap_bindPW) pfree(xm->ldap_bindPW);
+
+  for(i=0; ((i < MAXFLIST) && (xm->ldap_filter[i].index)); i++) {
+    pfree(xm->ldap_filter[i].index);
+    pfree(xm->ldap_filter[i].filter);
+  }
+  
+  for(i=0; ((i < MAXFLIST) && (xm->ldap_attrs[i].index)); i++) {
+    pfree(xm->ldap_attrs[i].index);
+    attrs_free(xm->ldap_attrs[i].attrs);
+  }
+
+  pfree(xm);
+}
+
+XMAP_METHOD *
+XMAP_METHOD_ldap( void )
+{
+  return (&xmap_ldap_methods);
+}
+
+#endif /* HAVE_LDAP */
+#endif /* OPENSSL */
